unit Unit3;

interface

uses sysutils,forms,classes,sockets,extctrls,graphics, XmlDoc,XMLIntf;


type
  TLovedek=class;

  Tjatekos=class
  private
    fLives: integer;
    procedure setlives(value:integer);

  public
    nev:string;
    x,y:integer;
    dx,dy:integer;
    rad:integer;
    img:Timage;
    color:TColor;
    Lovedek:TLovedek;
    Kills: integer;
    conn:Tcustomipclient;
    property Lives:integer read Flives write setlives;
    Constructor create(owner:Tcomponent;pimg:Timage);
    Procedure Rajzol(torol:boolean);
    Function eler(masik:Tjatekos):boolean;
    Procedure OneStep; virtual;
  protected
    dead:boolean;
    timestart,fulltime:double;
    Procedure SHOOT;
    Procedure ParseXML(s:string);
  end;

TLovedek=class(TJatekos)
    Jatekos:TJatekos;
    Procedure OneStep; override;
    Constructor create(owner:TJatekos;pimg:Timage;lx,ly,ldx,ldy:integer);
end;

var   t:TList;

implementation
uses unit2;


procedure Tjatekos.setlives(value:integer);
begin
    flives:=value;
    if flives=0 then
    begin
    nev:=nev+' deceived';
    dx:=0;
    dy:=0;
    dead:=true;
    end;
end;

Constructor Tjatekos.create(owner:Tcomponent;pimg:Timage);
begin
    x:=random(300);
    y:=random(300);
    conn:=Tcustomipclient.Create(owner);
    color:=clyellow;
    fulltime:=0;
    timestart:=now;
    img:=Pimg;
    rad:=30;
    dead:=false;
    dx:=0;
    dy:=0;
    Lives:=3;
    Kills:=0;
end;

Procedure TJatekos.Rajzol(torol: Boolean);
begin
  if torol then
    img.Canvas.Brush.Color:=clwhite
    else
      img.Canvas.Brush.Color:=color;
  img.Canvas.Ellipse(x-rad,y-rad,x+rad,y+rad);
  if not torol then
      img.Canvas.TextOut(x-rad div 2,y,nev);
end;

Procedure Tjatekos.OneStep;
var r,w,e:boolean;
    s:string;
    i:integer;
    masik:TJatekos;
    utkozik:boolean;
begin
  if conn.Active then
  begin
     r:=false;
     if not dead then
     conn.Select(@r,@w,@e);
     if r then
     begin
        s:=conn.Receiveln();
        if s<>'' then
        try
        parseXML(s);
        form2.Memo1.Lines.Add(s);
        except
           on e:Exception do ;
        end;
        if length(s)=0 then
           conn.Active:=false;
     end;
  end;
             rajzol(true);
           x:=x+dx;
           y:=y+dy;
           utkozik:=false;
           for I := 0 to T.Count - 1 do
           begin
               masik:=T[i];
              if masik<>self then
               if eler(masik) then
                 begin
                    utkozik:=true;
                 end;
           end;
           if utkozik then
           begin
               x:=x-dx;
               y:=y-dy;
           end;
           if x<rad then x:=rad;
           if x>700-rad then x:=700-rad;
           if y<rad then y:=rad;
           if y>600-rad then y:=600-rad;
           rajzol(false);

        if lovedek<>nil then
        begin
          lovedek.OneStep;
          if lovedek.dead then
          begin
             lovedek.Free;
             lovedek:=nil;
          end;
        end;

end;


Function Tjatekos.eler(masik:Tjatekos):boolean;
var d:real;
begin
    d:=sqrt(sqr(x-masik.x)+sqr(y-masik.y));
    result:=d<=rad+masik.rad;
end;

Procedure TJatekos.ParseXML(s:string);
var xml:TXMLDocument;
    Root,Node:IXMLNode;
    i:integer;
    c:char;
    ls:string;
begin
   try
    xml:=TXMLDocument.Create(application);
    xml.xml.text:=s;
    xml.Active:=true;
    Root:=xml.DocumentElement;
    if Root.NodeName='login' then
         self.nev:=root.NodeValue;
    if Root.NodeName='mozgas' then
          for i:= 0 to Root.ChildNodes.Count-1 do
              begin
                Node:=Root.ChildNodes[i];
                if Node.nodename='left' then
                     dx:=Node.nodevalue;
                if Node.nodename='up' then
                     dy:=Node.nodevalue;
                if Node.nodename='shoot' then
                begin
                   SHOOT;
                end;
              end;
   finally
      xml.Free;
   end;
end;

Procedure TJatekos.SHOOT;
begin
   if (lovedek=nil) and ((dx<>0)or  (dy<>0)) then
    begin
        lovedek:=Tlovedek.create(self,img,trunc(x+rad*dx/5),trunc(y+rad*dy/5),dx*2,dy*2);
    end;
end;


Constructor TLovedek.create(owner:TJatekos;pimg:Timage;lx,ly,ldx,ldy:integer);
begin
    x:=lx;
    y:=ly;
    img:=Pimg;
    Jatekos:=owner;
    color:=clred;
    rad:=5;
    dx:=ldx;
    dy:=ldy;
    dead:=false;
end;

Procedure TLovedek.OneStep;
var i:integer;
    masik:TJatekos;
begin
     rajzol(true);
       x:=x+dx;
       y:=y+dy;
       for i := 0 to T.Count - 1 do
       begin
          masik:=T[i];
          if (masik<>Jatekos)and (not masik.dead) then
             if eler(masik) then
              begin
                  masik.Lives:=masik.Lives-1;
                  dead:=true;
                  inc(jatekos.Kills);
                  rajzol(true);
              end;
       end;
       if (x<rad) or(x>700-rad) or (y<rad) or(y>600-rad) then dead:=true
       else
         rajzol(false);
end;




end.
