unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Sockets, ExtCtrls,xmldoc,xmlintf;

type
  TForm1 = class(TForm)
    TcpClient1: TTcpClient;
    edHost: TEdit;
    edPort: TEdit;
    edName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    Memo1: TMemo;
    Timer1: TTimer;
    Button2: TButton;
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  r,w,e : boolean;
  gleft,gright,gup,gdown:integer;
  space:boolean;
implementation

{$R *.dfm}

Procedure sendxml;
var Doc:TXMLDocument;
    root,node:IXMLNode;
begin
  Doc:=TXmlDocument.Create(Application);
  Doc.Active:=True;
  Root:=doc.CreateElement('mozgas','');
  Doc.DocumentElement:=Root;
  node:=root.AddChild('left');
  node.NodeValue:=-gleft+gright;
  node:=root.AddChild('up');
  node.NodeValue:=+gdown-gup;
  if space then
     root.AddChild('shoot');
  form1.TCPClient1.Sendln(doc.XML.Text,'');
  doc.Free;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  TCPClient1.RemoteHost:=edHost.Text;
  TCPClient1.RemotePort:=edPort.Text;
  TCPClient1.Connect;
  TCPClient1.Sendln('<login>'+edName.Text+'</login>');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  TCPClient1.Disconnect;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  gleft:=0;
  gright:=0;
  gup:=0;
  gdown:=0;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_LEFT  : gleft:=5;
    VK_RIGHT : gright:=5;
    VK_UP    : gup:=5;
    VK_DOWN  : gdown:=5;
    vk_space : space:=true;
  end;
  sendxml;
  space:=false;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   case Key of
    VK_LEFT  : gleft:=0;
    VK_RIGHT : gright:=0;
    VK_UP    : gup:=0;
    VK_DOWN  : gdown:=0;
  end;
  sendxml;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  tcpclient1.Select(@r,@w,@e);
    if r then
      Memo1.Lines.Add(TCPCLient1.Receiveln());
end;

end.
